From c78bed5d2434515100e42486de85aa6e0dbf5f52 Mon Sep 17 00:00:00 2001
From: Klaus Zimmermann <klaus_zimmermann@gmx.de>
Date: Thu, 20 Oct 2016 13:37:22 +0200
Subject: Improve umread building and handling

Signed-off-by: Klaus Zimmermann <klaus_zimmermann@gmx.de>
---
 cf/um/umread/c-lib/Makefile          | 14 +++++++-------
 cf/um/umread/c-lib/type-dep/Makefile |  6 ++++--
 2 files changed, 11 insertions(+), 9 deletions(-)

diff --git a/cf/um/umread/c-lib/Makefile b/cf/um/umread/c-lib/Makefile
index 98d0685..e0a6f4a 100644
--- a/cf/um/umread/c-lib/Makefile
+++ b/cf/um/umread/c-lib/Makefile
@@ -2,11 +2,10 @@ HEADERS=umfile.h umfileint.h bits/*.h
 
 LIBRARY=umfile.so
 
-CC=gcc
-CFLAGS=-Wall -fPIC -g
-CPP=gcc -E -P
-LD=ld
-LDFLAGS=-shared --build-id
+CC ?= gcc
+CFLAGS += -Wall -fPIC -g
+CPP ?= gcc -E -P
+LDFLAGS += -shared
 OBJS = umfile.o error.o filetype.o \
 	malloc.o linklist.o new_structs.o swap.o
 
@@ -28,10 +27,11 @@ type-dep:
 	$(MAKE) -C $(TYPE_DEP_DIR)
 
 $(LIBRARY): $(OBJS) type-dep
-	$(LD) $(LDFLAGS) -o $@ $(OBJS) --whole-archive $(TYPE_DEP_LIBRARY_PATH)
+	$(CC) $(LDFLAGS) $(TARGET_ARCH) \
+        $(OBJS) -Wl,--whole-archive $(TYPE_DEP_LIBRARY_PATH) -Wl,--no-whole-archive \
+        $(LDLIBS) -o $@
 
 %.o: %.c $(HEADERS)
-	$(CC) $(CFLAGS) -c $<
 
 #bits/protos_sgl.h: bits/type_dep_protos.h
 #	$(CPP) -DBUILD_HDR -DSINGLE $< > $@
diff --git a/cf/um/umread/c-lib/type-dep/Makefile b/cf/um/umread/c-lib/type-dep/Makefile
index 381c4a8..55edc85 100644
--- a/cf/um/umread/c-lib/type-dep/Makefile
+++ b/cf/um/umread/c-lib/type-dep/Makefile
@@ -24,11 +24,13 @@ all: $(LIB)
 clean:
 	rm -f $(OBJS) $(TMP_OBJS) $(LIB) $(REDEFINES_SGL) $(REDEFINES_DBL)
 
+%_dbl_tmp.o: CFLAGS += -DDOUBLE
 %_dbl_tmp.o: %.c $(HEADERS)
-	$(CC) $(CFLAGS) -c -DDOUBLE -o $@ $<
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $(OUTPUT_OPTION) $<
 
+%_sgl_tmp.o: CFLAGS += -DSINGLE
 %_sgl_tmp.o: %.c $(HEADERS)
-	$(CC) $(CFLAGS) -c -DSINGLE -o $@ $<
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $(OUTPUT_OPTION) $<
 
 %_sgl.o: %_sgl_tmp.o $(REDEFINES_SGL)
 	objcopy --redefine-syms=$(REDEFINES_SGL) $< $@
